]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- do not filter pear install message too much
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# vim:ts=4 sw=4 noet ft=spec
3#
4# PLD Linux rpm macros.
5# <http://www.pld-linux.org/>
6
7# can be used by builder script to check for version
8%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
9
10%epoch 0
11%x8664 x86_64 amd64 ia32e
12%arm armv3l armv4b armv4l armv5teb armv5tel
13
14# kernel compiler
15%kgcc %{__cc}
16%kgcc_package gcc
17
18# compiler version
19%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
20%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
21
22%__rm /bin/rm --interactive=never
23
24# Build system path macros.
25%__autoconf autoconf %{?debug:-Wall}
26%__automake automake -a -c -f --foreign
27%__autopoint autopoint --force
28
29# add parallel build flags: -jN
30#
31# if you want to disable parallel build do:
32# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
33#
34%__make /usr/bin/make %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
37%__cmake /usr/bin/cmake
38
39%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
40 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
41
42%__gettextize { \
43 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
44 gettextize --copy --force --no-changelog; \
45 else \
46 gettextize --copy --force --no-changelog --intl; \
47 fi; \
48 if [ ! -f po/Makevars ]; then \
49 cp -f po/Makevars{.template,}; \
50 fi; \
51}
52
53%__glib_gettextize glib-gettextize --copy --force
54%__gnome_doc_common gnome-doc-common --copy
55%__gnome_doc_prepare gnome-doc-prepare --copy --force
56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
58%__libtoolize libtoolize --copy --force --install
59
60# topdir is where builder script lives,
61# fallback to old style if SPECS/SOURCES dirs were found.
62%_topdir %{expand:%%global _topdir %(
63 if [ -d SPECS -a -d SOURCES ]; then
64 # old style rpmdir: in topdir
65 pwd
66 elif [ -d ../SPECS -a -d ../SOURCES ]; then
67 # old style rpmdir: in subdir
68 cd ..; pwd
69 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
70 # if old style rpm dir exist, go with it
71 echo $HOME/rpm; \
72 elif [ -x ../builder -a ! -d ../builder ]; then
73 # relative new style rpmdir: in package dir
74 cd ..; pwd
75 elif [ -x builder -a ! -d builder ]; then
76 # relative new style rpmdir: in packages
77 pwd
78 elif [ -x packages/builder -a ! -d packages/builder ]; then
79 # relative new style rpmdir: packages dir in current dir
80 cd packages; pwd
81 else
82 # fallback to new style rpmdir
83 echo $HOME/rpm/packages
84 fi; \
85)}%_topdir
86
87# if %{_topdir}/SPECS exists, it's old style structure
88%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
89%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
90
91# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
92# if they don't exist assume we are having custom topdir (which is not named as
93# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
94# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
95%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
96%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
97%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
98
99# The number of cvs changelog entries kept when building package.
100%_buildchangelogtruncate 20
101
102%dependencytracking %{nil}
103
104# Relations between package names that cause dependency loops
105# with legacy packages that cannot be fixed. Relations are
106# specified as
107# p>q
108# where package p has a Requires: on something that package q Provides:
109#
110# XXX Note: that there cannot be any whitespace within the string "p>q",
111# and that both p and q are package names (i.e. no version/release).
112%_dependency_whiteout %{nil}
113
114#-----------------------------------------------------------------
115#
116# (re)definition of %{rpm*flags} with %filterout_* support
117# BuildRequires: awk
118# BuildRequires: rpmbuild(macros) >= 1.315
119#
120# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
121# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
122# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
123# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
124# %rpmldflags = %optldflags - %filterout_ld
125#
126# Regular expressions are supported, but to avoid some character be treated
127# as regular expression it must be escaped twice.
128
129%filter_out \
130 for (i = 1; i in I; i++) { A=0; \
131 for (f in F) { \
132 if (I[i] ~ "^" F[f] "$") A=1; \
133 }; \
134 if (!A) printf(I[i] FS); \
135 }
136
137%rpmcflags %(awk 'BEGIN {
138 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
139 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
140 %{filter_out}
141}')
142
143%rpmcxxflags %(awk 'BEGIN {
144 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
145 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
146 %{filter_out}
147}')
148
149%rpmcppflags %(awk 'BEGIN {
150 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
151 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
152 %{filter_out}
153}')
154
155%rpmldflags %(awk 'BEGIN {
156 split("%{?optldflags}",I);
157 split("%{?filterout_ld}",F)
158 %{filter_out}
159}')
160
161# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
162# but, don't use it, better use gcc as linker
163%ld_rpmldflags %(awk 'BEGIN {
164 split("%{rpmldflags}",F);
165 for (f in F) {
166 s = F[f];
167 if (s ~ /^-Wl,/) {
168 s = substr(s,5);
169 gsub(/,/," ",s);
170 };
171 printf(s FS);
172 };
173}')
174
175#-----------------------------------------------------------------
176#
177# Generate a command which cleans environment, leaving only the
178# most important variables.
179# If any spec requires any additional environment it should
180# redefine %_preserve_env in following manner:
181#
182# # ADDITIONAL_VAR is required because [a good reason here]
183# %define _preserve_env ADDITIONAL_VAR
184
185%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
186
187# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
188%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
189 split("%{?_preserve_env}", P);
190 for (i in P) {
191 p = P[i];
192 if (!ENVIRON[p] || d[p]) {
193 continue;
194 }
195 d[p] = 1;
196 split(ENVIRON[p], V, "");
197 val = p "=";
198 for (j = 1; j in V; j++) {
199 v = V[j];
200 if (v == q)
201 v = qq;
202 else if (v == "\\"")
203 v = q2q;
204 else if (v == "\\\\")
205 v = "\\\\\\\\";
206 else
207 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
208 val = val "" v;
209 }
210 printf(val " ");
211 }
212}')
213
214#-----------------------------------------------------------------
215%configure2_13 { \
216 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
217 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
218 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
219 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
220 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
221 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
222 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
223 %{?__cc:CC="%{__cc}" ; export CC ; } \
224 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
225 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
226 --host=%{_target_platform} \
227 --prefix=%{_prefix} \
228 --exec-prefix=%{_exec_prefix} \
229 --bindir=%{_bindir} \
230 --sbindir=%{_sbindir} \
231 --sysconfdir=%{_sysconfdir} \
232 --datadir=%{_datadir} \
233 --includedir=%{_includedir} \
234 --libdir=%{_libdir} \
235 --libexecdir=%{_libexecdir} \
236 --localstatedir=%{_localstatedir} \
237 --sharedstatedir=%{_sharedstatedir} \
238 --mandir=%{_mandir} \
239 --infodir=%{_infodir} \
240 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
241 %{dependencytracking} \
242}
243
244%cmake \
245%{?__cc:CC="%{__cc}"} \\\
246%{?__cxx:CXX="%{__cxx}"} \\\
247CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
248%{__cmake} \\\
249 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
250 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
251 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
252 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
253 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
254 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
255 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
256 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
257 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
258 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
259 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
260 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
261 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
262 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
263%if "%{_lib}" == "lib64" \
264 -DLIB_SUFFIX=64 \\\
265%endif \
266 -DBUILD_SHARED_LIBS:BOOL=ON \\\
267%{nil}
268
269%scons { \
270%{__scons} \
271 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
272 CFLAGS="${CFLAGS:-%rpmcflags}" \
273 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
274 FFLAGS="${FFLAGS:-%rpmcflags}" \
275 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
276 %{?__cc:CC="%{__cc}"} \
277 %{?__cxx:CXX="%{__cxx}"} \
278 libsuffix=%{_lib} \
279 prefix=%{_prefix} \
280}
281
282# waf. see waf.spec
283%waf { \
284CC="%{__cc}" \
285CXX="%{__cxx}" \
286CPP="%{__cpp}" \
287CFLAGS="%{rpmcflags}" \
288CXXFLAGS="%{rpmcxxflags}" \
289%{__waf} \
290}
291
292#----------------------------------------------------------------
293#%configure_cache 0
294%configure_cache_file %{buildroot}.configure.cache
295
296%configure {./configure \
297 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
298 CFLAGS="${CFLAGS:-%rpmcflags}" \
299 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
300 FFLAGS="${FFLAGS:-%rpmcflags}" \
301 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
302 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
303 %{?__cc:CC="%{__cc}"} \
304 %{?__cxx:CXX="%{__cxx}"} \
305 --host=%{_target_platform} \
306 --build=%{_target_platform} \
307 --prefix=%{_prefix} \
308 --exec-prefix=%{_exec_prefix} \
309 --bindir=%{_bindir} \
310 --sbindir=%{_sbindir} \
311 --sysconfdir=%{_sysconfdir} \
312 --datadir=%{_datadir} \
313 --includedir=%{_includedir} \
314 --libdir=%{_libdir} \
315 --libexecdir=%{_libexecdir} \
316 --localstatedir=%{_localstatedir} \
317 --sharedstatedir=%{_sharedstatedir} \
318 --mandir=%{_mandir} \
319 --infodir=%{_infodir} \
320 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
321 %{dependencytracking} \
322 %{?configure_cache:--cache-file=%{configure_cache_file}} \
323}
324
325# Simple macros to simplify adding bconded options to configure scripts.
326# Each macro requires bcond name and accepts optional option name, if option
327# isn't specified bcond name is used as option name. Options returning
328# --with and --enable also allow third argument which will be added as value
329# ( --with-option=value or --enable-option=value ) in case or positive
330# condition, but won't be added otherwise ( nothing or just --disable-option ).
331
332# Requirements:
333# BuildRequires: rpmbuild(macros) >= 1.527
334
335# Usage example:
336# %{__enable bcond} - returns --enable-bcond iff build condition is set
337# %{__disable bcond option} - returns --enable-option iff bcond is not set
338# %{__enable_disable bcond option value} - returns --enable-option=value if
339# bcond is set, returns --disable-option otherwise
340
341# expand bconds to --enable-something and --disable-something
342%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
343%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
344%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
345
346# same as above, but condition inverted
347%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
348%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
349%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
350
351# expand bconds to --with-something and --without-something
352%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
353%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
354%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
355
356# same as above, but condition inverted
357%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
358%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
359%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
360
361#-----------------------------------------------------------------
362
363# overload to insert debuginfo package
364%prep \
365%if 0%{?_enable_debug_packages}\
366%{debug_package}\
367%endif\
368%%prep\
369%{nil}
370
371# Location of autoconf macros
372%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
373
374# Location of omf files
375%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
376
377# Location of pkgconfig files
378%_pkgconfigdir /usr/%{_lib}/pkgconfig
379# noarch pkgconfig files
380%_npkgconfigdir /usr/share/pkgconfig
381
382# Location of desktop files
383%_desktopdir /usr/share/applications
384%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
385
386# Location of pixmaps for applnk/desktop files
387%_pixmapsdir /usr/share/pixmaps
388
389# Location of themable icons for applnk/desktop files
390%_iconsdir /usr/share/icons
391
392# Location of fonts directories
393%_fontsdir /usr/share/fonts
394
395# Location of Gtk and associated libraries documentation
396%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
397
398# Location of KDE documentation
399%_kdedocdir %{_defaultdocdir}/kde/HTML
400
401# unsermake script
402%__unsermake /usr/share/unsermake/unsermake
403
404# Current date
405%date %(LC_ALL=C date +"%a %b %d %Y")
406
407# Example files, programs, scripts...
408%_examplesdir /usr/src/examples
409
410# Alternative kernel type/version
411%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
412
413# The directory holding Linux kernel sources
414%_kernelsrcdir /usr/src/linux%{_alt_kernel}
415
416# SysV-style initscripts dir
417%_initddir /etc/rc.d/init.d
418
419# If non-empty "debug" macro defined, add "dbg" suffix to release number
420%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
421
422# Bootstrap release macros.
423# Usage:
424# %bcond_with bootstrap
425# Release: %{bootstrap_release 1}
426#
427# Package will have release 1 if built normally,
428# and release 0.zzz.bootstrap if built with bootstrap
429%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
430
431# -n drm to generate kernel%{_alt_kernel}-drm dependency
432%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
433%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
434%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
435
436# -s post to generate Requires(post) dependency
437%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
438%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
439%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
440
441# Requires name = version-release
442%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
443# Requires: name = version
444%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
445# Requires: name = version (version based on querying package %2)
446%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
447
448# Requires: name >= version
449%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
450# Requires: name >= version (version based on querying package %2)
451%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
452
453%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
454
455# kernel version-release handling
456%__kernel_ver %{expand:%%global __kernel_ver %( \\
457 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
458 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
459 echo ${Z:-ERROR}; \\
460)}%__kernel_ver
461
462%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
463%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
464%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
465%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
466
467# `uname -r` to be used in @release field
468%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
469
470# sgml macros
471%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
472%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
473%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
474%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
475%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
476%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
477%docbook_sgmlcat_fix() { for l in \
478'' \
479' -- default decl --' \
480'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
481' -- hacks for opensp --' \
482'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
483'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
484'' \
485; do echo $l; done >> %1 \
486}
487
488# vim - "
489
490# minimum file size needed for compressed documents.
491# just smaller files than this get larger when compressed.
492# some stats:
493# - 0 byte file compressed was 25 bytes .gz
494# - 39 byte file was compressed as 57
495# - with test/test.spec@man 158 byte file was compressed also 158
496%_min_compress_bytes 159
497
498#-----------------------------------------------------------------
499# find and gzip all files in %{_mandir} and %{infodir}
500#
501# Requires: xargs, find
502#
503#%no_install_post_compress_docs 1
504%__spec_install_post_compress_docs { \
505%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
506 for i in /usr/share/man /usr/X11R6/man; do \
507 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
508 echo "Compress man pages: $i"; \
509 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
510 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
511 find $RPM_BUILD_ROOT$i -type l | while read a; do \
512 m=$(readlink $a); \
513 rm -f $a; \
514 echo .so ${m##*/} > $a; \
515 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
516 done; \
517 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
518 fi; \
519 done; \
520 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
521 echo "Compress info pages: %{_infodir}"; \
522 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
523 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
524 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
525 fi; \
526}; __spec_install_post_compress_docs } }
527
528#-----------------------------------------------------------------
529# Strip executable binaries and shared object files
530#
531# Requires: find, awk, strip, cut, xargs
532#
533# Special macros which affect this process:
534#%no_install_post_strip 1 # disable stripping at all
535#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
536#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
537#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
538#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
539#
540%__spec_install_post_strip {%{!?debug: \
541%{!?no_install_post_strip:__spec_install_post_strip() { \
542if [ -d "$RPM_BUILD_ROOT" ]; then \
543 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
544 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
545 if [ "$modulelist" ]; then \
546 modulecount=$(echo "$modulelist" | wc -l); \
547 printf "Stripping %d kernel modules..." $modulecount; \
548 echo "$modulelist" | xargs -l512 chmod u+w; \
549 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
550 echo "DONE"; \
551 fi; \
552 fi; \
553 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
554 if [ -n "$filelist" ]; then \
555 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
556 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
557 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
558 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
559 if [ -n "$elfexelist" ]; then \
560 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
561 chmod u+w $elfexelist; \
562 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
563 echo "DONE"; \
564 fi; \
565 if [ -n "$elfsharedlist" ]; then \
566 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
567 chmod u+w $elfsharedlist; \
568 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
569 echo "DONE"; \
570 fi; \
571 if [ -n "$archiveslist" ]; then \
572 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
573 chmod u+w $archiveslist; \
574 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
575 echo "DONE"; \
576 fi; \
577 fi; \
578 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
579 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
580 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
581 if [ -n "$filelist_all" ]; then \
582 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
583 chmod u+w $filelist_all; \
584 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
585 echo "DONE"; \
586 fi; \
587 if [ -n "$filelist_unneeded" ]; then \
588 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
589 chmod u+w $filelist_unneeded; \
590 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
591 echo "DONE"; \
592 fi; \
593 if [ -n "$filelist_debug" ]; then \
594 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
595 chmod u+w $filelist_debug; \
596 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
597 echo "DONE"; \
598 fi; \
599fi; }; __spec_install_post_strip } } }
600
601#-----------------------------------------------------------------
602# remove all RPATH from executable binaries and shared object files
603#
604# Requires: find, awk, cut, xargs, chrpath, uname
605#
606# Special macros which affect this process
607#%no_install_post_chrpath 1 # disable chrpath at all
608#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
609#
610%__spec_install_post_chrpath {%{!?debug: \
611%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
612if [ -d "$RPM_BUILD_ROOT" ]; then \
613 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
614 if [ -n "$files" ]; then \
615 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
616 fi; \
617 if [ -n "$objs" ]; then \
618 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
619 echo "$objs" | \
620 while read file; do \
621 rpath= ; \
622 chmod u+w "$file"; \
623 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
624 case $dir in \
625 '$ORIGIN' ) \
626 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
627 else rpath="$rpath:$dir" ; fi ; \
628 continue ; \
629 ;; \
630 esac ; \
631 newdir=$(readlink -m "$dir"); \
632 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
633 case $dir in \
634 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
635 echo "remove-rpath: $dir in $file"; \
636 ;; \
637 * ) \
638 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
639 else rpath="$rpath:$dir" ; fi ; \
640 ;; \
641 esac ; \
642 done ; \
643 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
644 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
645 done; \
646 fi; \
647fi; }; __spec_install_post_chrpath } } }
648
649# vim: "
650
651#-----------------------------------------------------------------
652# Find all shared object files with unresolved symbols. Warn
653# and terminate if any found (termination can be turned off by define).
654#%no_install_post_check_so 1
655#%skip_post_check_so libwithunresolvedok.so.*
656#
657# NOTE: define skip_post_check_so only if such library really requires
658# unresolved symbols and always leave a comment why it is required:
659# # executable provides symbols foo, bar for those libraries:
660# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
661#
662%__spec_install_post_check_so { \
663__spec_install_post_check_so() { \
664 fail=0; \
665 printf "Searching for shared objects with unresolved symbols..."; \
666 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
667 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
668 done ; \
669 echo " DONE"; \
670 %{!?no_install_post_check_so:return $fail;} \
671}; __spec_install_post_check_so }}
672
673#-----------------------------------------------------------------
674# Find and gzip all kernel modules
675#
676# Requires: find
677#
678#%no_install_post_compress_modules 1
679%__spec_install_post_compress_modules { \
680%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
681 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
682 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
683 if [ "$q" ]; then \
684 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
685 echo "$q" | xargs -r %{__gzip} -9nf; \
686 echo "DONE"; \
687 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
688 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
689 fi; \
690 fi; \
691}; __spec_install_post_compress_modules } }
692
693# Remove common Perl files we don't package
694%__spec_install_post_perl_clean {\
695%{!?no_install_post_perl_clean: \
696%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
697} }
698
699#-----------------------------------------------------------------
700# Update GConf2 schemas
701#
702# Requires: GConf2
703#
704%gconf_schema_install() \
705 umask 022; \
706 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
707 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
708%{nil}
709
710%gconf_schema_uninstall() \
711if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
712 umask 022; \
713 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
714 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
715fi; \
716%{nil}
717
718#-----------------------------------------------------------------
719# Update desktop MIME database
720# requires: desktop-file-utils
721%update_desktop_database() {{ \
722 umask 022; \
723 /usr/bin/update-desktop-database -q; \
724};} \
725%{nil}
726
727%update_desktop_database_post %update_desktop_database
728
729%update_desktop_database_postun() {{ \
730if [ "$1" = "0" ]; then \
731 %update_desktop_database \
732fi; \
733};} \
734%{nil}
735
736#-----------------------------------------------------------------
737# Update shared MIME info database
738# requires: shared-mime-info
739#
740%update_mime_database() {{ \
741 umask 022; \
742 /usr/bin/update-mime-database %{_datadir}/mime; \
743};} \
744%{nil}
745
746#-----------------------------------------------------------------
747# Update icon cache
748# BuildRequires: rpmbuild(macros) >= 1.596
749# Requires: hicolor-icon-theme
750#
751%update_icon_cache() {{ \
752 %{!?1:%{error:%{0}: Required theme name missing}} \
753 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
754 umask 022; \
755 touch --no-create %{_iconsdir}/%1; \
756 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
757 fi; \
758};} \
759%{nil}
760
761#-----------------------------------------------------------------
762# Update scrollkeeper database
763# requires: scrollkeeper
764#
765%scrollkeeper_update_post() \
766 /usr/bin/scrollkeeper-update -q; \
767%{nil}
768
769%scrollkeeper_update_postun() \
770if [ "$1" = "0" ]; then \
771 /usr/bin/scrollkeeper-update -q; \
772fi; \
773%{nil}
774
775#-----------------------------------------------------------------
776# Compile GSettings schemas
777# requires: glib2 >= 1:2.26.0
778#
779%glib_compile_schemas() {{ \
780 umask 022; \
781 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
782};} \
783%{nil}
784
785#-----------------------------------------------------------------
786# post %install sequence:
787# - autodeps exceptions
788# - compress all man and info pages,
789# - strip all ELF executables and ELF shared objects if not %debug.
790# - compress kernel modules if any
791
792###################################################################
793# Requires/Provides automation
794# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
795#
796%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
797%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
798%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
799%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
800%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
801
802#%_noautocompressdoc %{nil}
803#
804%_missing_doc_files_terminate_build 1%{nil}
805%_unpackaged_files_terminate_build %{nil}
806# (X)emacs support
807%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
808%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
809%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
810
811%__php_provides %{nil}
812%__php_requires %{nil}
813%__perl_provides %{nil}
814%__perl_requires %{nil}
815%__mono_provides %{nil}
816%__mono_requires %{nil}
817
818# Perl specific macro definitions.
819%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
820%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
821%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
822%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
823%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
824%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
825
826# Ruby
827%__ruby /usr/bin/ruby
828%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
829%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
830%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
831%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
832%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
833%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
834%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
835%ruby_rdocdir /usr/share/rdoc
836%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
837%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
838%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
839
840%php_pear_dir /usr/share/pear
841%php_data_dir /usr/share/php
842%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
843%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
844%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
845
846# extract php/zend api versions
847%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
848%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
849%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
850%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
851%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
852%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
853%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
854%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
855# "_ts" if ZTS enabled, empty otherwise
856%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
857
858# helper macro
859%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
860
861# macros for public use
862# for php extensions (php-pecl)
863%requires_php_extension %{__php_api_requires modules_api php_api_version} \
864%{__php_api_requires zend_module_api} \
865%{__php_api_requires -v %php_major_version debug php_debug} \
866%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
867
868# for zend extensions
869%requires_zend_extension %{__php_api_requires zend_module_api} \
870%{__php_api_requires zend_extension_api} \
871%{__php_api_requires -v %php_major_version debug php_debug} \
872%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
873
874# for php pdo modules (php-pecl-PDO_*)
875%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
876
877# for using PHP post scripts. for PHP >= 5.0
878%php_webserver_restart \
879[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
880[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
881if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
882 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
883 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
884 %service -q php-fcgi restart \
885 fi \
886fi \
887if [ -x /etc/rc.d/init.d/php-fpm ]; then \
888 %service -q php-fpm restart \
889fi \
890%{nil}
891
892# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
893%php4_webserver_restart \
894[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
895[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
896if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
897 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
898 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
899 %service -q php-fcgi restart \
900 fi \
901fi \
902%{nil}
903
904# X.org helper macros
905%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
906%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
907
908%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
909%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
910%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
911%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
912%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
913# vim: '
914
915%requires_xorg_xserver_extension \
916%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
917%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
918%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
919%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
920%{nil}
921
922%requires_xorg_xserver_xinput \
923%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
924%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
925%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
926%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
927%{nil}
928
929%requires_xorg_xserver_font \
930%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
931%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
932%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
933%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
934%{nil}
935
936%requires_xorg_xserver_videodrv \
937%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
938%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
939%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
940%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
941%{nil}
942
943# TCL specific macro definitions.
944# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
945%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
946%tcl_sitearch %{_libdir}/tcl%{tcl_version}
947%tcl_sitelib %{_datadir}/tcl%{tcl_version}
948
949# Python specific macro definitions.
950# python main version
951%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
952
953# directories
954%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
955%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
956%py_scriptdir %{py_prefix}/share/python%{py_ver}
957%py_incdir /usr/include/python%{py_ver}
958%py_sitedir %{py_libdir}/site-packages
959%py_sitescriptdir %{py_scriptdir}/site-packages
960%py_dyndir %{py_libdir}/lib-dynload
961
962# pure python modules compilation
963%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
964
965%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
966
967# Software written in Python language require Python with main version
968%pyrequires_eq() Requires: %1
969
970# Python 3.x
971# python main version
972%__python3 python3
973%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
974
975# directories
976%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
977%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
978%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
979%py3_incdir /usr/include/python%{py3_ver}
980%py3_sitedir %{py3_libdir}/site-packages
981%py3_sitescriptdir %{py3_scriptdir}/site-packages
982%py3_dyndir %{py3_libdir}/lib-dynload
983
984# pure python modules compilation
985%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
986
987%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
988
989
990# Hardlink binary identical .pyc and .pyo files
991%__spec_install_post_py_hardlink {\
992%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
993local a b c=0 t=0; \
994if [ -d "$RPM_BUILD_ROOT" ]; then \
995 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
996 while read a; do \
997 b="${a%.pyc}.pyo"; \
998 if cmp -s "$a" "$b"; then \
999 ln -f "$a" "$b"; \
1000 c=$((c + 1)); \
1001 fi; \
1002 t=$((t + 1)); \
1003 done < __rpm_pyc; \
1004 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1005 rm -f __rpm_pyc; \
1006fi; \
1007}; __spec_install_post_py_hardlink } }
1008
1009# remove python sources, so that check-files won't complain
1010%py_postclean() \
1011for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1012 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1013done \
1014%{nil}
1015
1016%py3_postclean() \
1017for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
1018 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1019done \
1020%{nil}
1021
1022# depmod macro
1023%depmod() { \
1024umask 022; \
1025if [ -e /boot/System.map-%1 ]; then \
1026 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1027else \
1028 if [ -e /boot/System.map ]; then \
1029 /sbin/depmod -a -F /boot/System.map %1; \
1030 else \
1031 /sbin/depmod -a %1; \
1032 fi \
1033fi; \
1034}
1035
1036# XMMS specific macros
1037%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1038%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1039%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1040%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1041%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1042%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1043%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1044%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1045%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1046%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1047
1048%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1049
1050# user/group checking macros
1051#
1052# Usage:
1053# %userremove myuser
1054#
1055%userremove /usr/lib/rpm/user_group.sh user del
1056%groupremove /usr/lib/rpm/user_group.sh group del
1057#
1058# Usage:
1059# if %usertestrm myuser; then
1060# /usr/sbin/userdel -r myuser
1061# Note:
1062# use these macros only if you need to call userdel/groupdel with
1063# a non-standard option or take an extra action; otherwise use the
1064# %userremove/%groupremove macros
1065#
1066%usertestrm /usr/lib/rpm/user_group.sh user testrm
1067%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1068# user group membership management macros
1069#
1070# Usage:
1071# %addusertogroup [-q] myuser agroup
1072#
1073# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1074#
1075# Requirements:
1076# BuildRequires: rpmbuild(macros) >= 1.515
1077%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1078%{nil}
1079
1080# banner support (useful in {pre,post}{,un} and triggers)
1081#
1082# Usage:
1083# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1084# the banner text, the banner text
1085# the banner text, and following line
1086#EOF
1087# You can use any form of here-document, <<'EOF' <<-EOT will do.
1088# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1089#
1090# -a - append to the banner
1091# -e - send to stderr instead of stdout
1092# -n - no show banner (overrides -t)
1093# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1094# -o - show only once, i.e when package is installed for the first time
1095#
1096# Tests:
1097# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1098# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1099# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1100# rpm -E 'date | %banner -e banner' > m; sh -x m
1101# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1102#
1103%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1104RPM_SCRIPTVERBOSITY=5 \
1105[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1106if [ -x /usr/bin/banner.sh ]; then \
1107 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1108else \
1109 CMD="cat%{-e: >&2}" \
1110fi \
1111eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1112%{nil}
1113
1114# useradd/groupadd macros
1115# Author: Elan Ruusamäe <glen@pld-linux.org>
1116#
1117# Usage:
1118# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1119# [-g initial_group] [-G group[,...]] login
1120#
1121# -u uid. REQUIRED
1122# -g gid/group. REQUIRED
1123# -s defaults to /bin/false
1124# -d defaults to /usr/share/empty
1125# -c No default
1126# -r is accepted but ignored (it's always set)
1127# -k skeleton dir. defaults to /usr/share/empty
1128# rpm specific flags
1129# -P package name. defaults to %{name}
1130#
1131%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1132%{!-u:%{error:useradd: Required argument -u missing}} \
1133%{!-g:%{error:useradd: Required argument -g missing}} \
1134%{!?1:%{error:useradd: Required parameter login missing}} \
1135if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1136 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1137 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1138 exit 1 \
1139 fi \
1140else \
1141 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1142 /usr/sbin/useradd \\\
1143 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1144 -u %{-u*} \\\
1145 -r \\\
1146 -d %{-d*}%{!-d:/usr/share/empty} \\\
1147 -s %{-s*}%{!-s:/bin/false} \\\
1148 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1149 -g %{-g*} \\\
1150 %{-M} \\\
1151 %{-G:-G %{-G*}} \\\
1152 %{expand:%{%{#}}} 1>&2 || exit $? \
1153 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1154fi;
1155# vim: "
1156
1157# Usage:
1158# %groupadd [-P package] [-g gid] group
1159#
1160# -g gid. REQUIRED
1161#
1162# Sample:
1163# %groupadd -P %{name}-base -g %{gid} %{name}
1164
1165%groupadd(g:P:rfo) \
1166%{!-g:%{error:groupadd: Required argument -g missing}} \
1167%{!?1:%{error:groupadd: Required parameter group missing}} \
1168if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1169 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1170 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1171 exit 1 \
1172 fi \
1173else \
1174 echo "Adding group %{1} GID=%{-g*}." \
1175 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1176 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1177fi;
1178
1179# webapp macros
1180# Author: Elan Ruusamäe <glen@pld-linux.org>
1181#
1182# The config is installed/removed inside trigger, this means that you can any
1183# time install apache1/apache/lighttpd package and the configuration file is
1184# updated. if you don't need the config for various reason for specific
1185# webserver, just remove the symlink from config directory using webapp
1186# program. the trigger will not recreate the symlink on upgrades. In other
1187# words the config is linked to webserver config directory on first install of
1188# PACKAGE or WEBSERVER.
1189#
1190# Add package's webserver config to webserver webapps dir.
1191# Usage:
1192# %webapp_register [-f] WEBSERVER WEBAPP
1193#
1194%webapp_register(f) \
1195%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1196if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1197 /usr/sbin/webapp register %1 %2\
1198fi\
1199# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1200if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1201 %{expand:%service -q %%1 reload}\
1202fi\
1203%{nil}
1204
1205# Remove package's config from webserver webapps dir.
1206# Usage:
1207# %webapp_register [-f] WEBSERVER WEBAPP
1208%webapp_unregister(f) \
1209%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1210# remove link if either of the packages are gone \
1211if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1212 /usr/sbin/webapp unregister %1 %2\
1213 %{expand:%service -q %%1 reload}\
1214fi \
1215%{nil}
1216
1217# service macro.
1218# Author: Elan Ruusamäe <glen@pld-linux.org>
1219#
1220# calls usual service restart on package %post, but skips the restart if
1221# administrator has disabled automatic service restarts in either global
1222# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1223#
1224# Usage:
1225# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1226#
1227# -q be silent when service isn't started (for scriplets restaring other package's services)
1228# -n NOOP mode, do not actually restart service
1229#
1230# Requirements:
1231# BuildRequires: rpmbuild(macros) >= 1.268
1232# Requires: rc-scripts
1233# -n option:
1234# BuildRequires: rpmbuild(macros) >= 1.450
1235%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1236
1237
1238# Java macros. based on jpackage macros.java
1239#
1240# Root directory where all Java VMs/SDK/JREs are installed.
1241%_jvmdir %{_libdir}/jvm
1242
1243# Root directory where all Java VMs/SDK/JREs expose their jars
1244%_jvmjardir %{_libdir}/jvm-exports
1245
1246# Root directory for all Java VM/SDK/JRE's private things.
1247%_jvmprivdir %{_libdir}/jvm-private
1248
1249# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1250%_jvmlibdir %{_libdir}/jvm
1251
1252# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1253%_jvmdatadir %{_datadir}/jvm
1254
1255# Root directory for all configurations parts of Java VM/SDK/JRE's
1256%_jvmsysconfdir %{_sysconfdir}/jvm
1257
1258# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1259%_jvmcommonlibdir %{_libdir}/jvm-common
1260
1261# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1262%_jvmcommondatadir %{_datadir}/jvm-common
1263
1264# Root directory for all common configurations parts of Java VM/SDK/JRE's
1265%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1266
1267# Directory where arch-specific (JNI) version-independent jars are installed.
1268%_jnidir %{_libdir}/java
1269
1270
1271# JDK selection. Set this to name of the JDK implementation to use
1272# insead of the system default
1273#%use_jdk icedtea6
1274
1275# expands to the value with right jdk for BuildRequires header
1276# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1277# The requirement will not replace current 'default' JDK
1278%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1279
1280%buildrequires_jdk BuildRequires: %required_jdk
1281
1282%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1283
1284%_javasrcdir %{_usrsrc}/java
1285
1286%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1287%jar %{java_home}/bin/jar
1288%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1289%javac %{java_home}/bin/javac
1290%javadoc %{java_home}/bin/javadoc
1291
1292%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1293
1294%jpackage_script() \
1295install -d $RPM_BUILD_ROOT%{_bindir}\
1296cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1297#!/bin/sh\
1298#\
1299# %{name} script\
1300# JPackage Project <http://www.jpackage.org/>\
1301\
1302# Source functions library\
1303. %{_javadir}-utils/java-functions\
1304\
1305# Source system prefs\
1306if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1307 . %{_sysconfdir}/java/%{name}.conf\
1308fi\
1309\
1310# Source user prefs\
1311if [ -f $HOME/.%{name}rc ]; then\
1312 . $HOME/.%{name}rc\
1313fi\
1314\
1315# Configuration\
1316MAIN_CLASS=%1\
1317BASE_FLAGS=%2\
1318BASE_OPTIONS=%3\
1319BASE_JARS="%(echo %4 | tr ':' ' ')"\
1320\
1321# Set parameters\
1322set_jvm\
1323set_classpath $BASE_JARS\
1324set_flags $BASE_FLAGS\
1325set_options $BASE_OPTIONS\
1326\
1327# Let's start\
1328run "$@"\
1329EOF
1330
1331# jpackage 1.7
1332# Directory for maven depmaps
1333#
1334%_mavendepmapdir /etc/maven
1335%_mavendepmapfragdir /etc/maven/fragments
1336
1337#
1338# add_to_depmap adds an entry to the depmap. The arguments are:
1339#
1340# %1 the original groupid
1341# %2 the original artifact id
1342# %3 the version
1343# %4 the new groupid
1344# %5 the new artifactid
1345#
1346
1347%add_to_maven_depmap() \
1348install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1349cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1350<dependency>\
1351 <maven>\
1352 <groupId>%1</groupId>\
1353 <artifactId>%2</artifactId>\
1354 <version>%3</version>\
1355 </maven>\
1356 <jpp>\
1357 <groupId>%4</groupId>\
1358 <artifactId>%5</artifactId>\
1359 <version>%3</version>\
1360 </jpp>\
1361</dependency>\
1362\
1363EOF\
1364%{nil}
1365
1366#==============================================================================
1367#
1368# update_maven_depmap updates the main maven depmap
1369#
1370%update_maven_depmap() \
1371echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1372if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1373cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1374fi\
1375echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1376
1377# JAVA macros specific for PLD
1378
1379# Directory for tomcat context configuration files
1380%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1381
1382# Tomcat cache path
1383%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1384
1385# Clear tomcat cache
1386# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1387#
1388# Usage:
1389# %%tomcat_clear_cache appname
1390#
1391# Call this script in %postun scriptlet. It will remove compiled jsps related to
1392# given app.
1393#
1394%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1395
1396# PEAR install macros
1397# Author: Elan Ruusamäe <glen@pld-linux.org>
1398#
1399# Usage:
1400# %%pear_package_setup ...
1401#
1402# -a # - also unpack SOURCE#. for PEAR bootstrapping
1403# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1404# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1405# -D - pass -D to %setup (so the build dir is not removed)
1406# -c - register channel from local channel.xml file
1407# -d - pass -d arg to pearcmd
1408#
1409# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1410# destination hierarchy. you should copy the tree to buildroot after
1411# patching/reorganizing with %%pear_package_install.
1412#
1413# additionally BUILDROOT is stripped from files and files are converted to UNIX
1414# line endings.
1415#
1416# the pear install process output is recorded to install.log, you should put it
1417# to %%doc for later debug or just for information.
1418#
1419# additionally additional-packages.txt is produced if it was detected that the
1420# package has optional dependencies. the file format is suitable of displaying
1421# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1422# automatically added for this file.
1423
1424
1425# records install.log and transforms PEAR names to PLD Linux rpm package names.
1426%__pear_install_log \
1427tee install.log \
1428# make post message of optional packages \
1429grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1430if [ -s optional-packages.txt ]; then \
1431 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1432else \
1433 rm -f optional-packages.txt \
1434fi \
1435%{nil}
1436
1437# Command invoking PEAR CLI
1438# Same as /usr/bin/pear, except we force GMT timezone
1439%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
1440
1441%pear_install(a:d:n:zD) \
1442%__pear \\\
1443 -c %{builddir}/pearrc \\\
1444 -d doc_dir=/docs \\\
1445 -d temp_dir=/tmp \\\
1446 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1447 -d bin_dir=%{_bindir} \\\
1448 -d data_dir=%{php_pear_dir}/data \\\
1449 -d test_dir=%{php_pear_dir}/tests \\\
1450 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1451 install \\\
1452 --packagingroot=%{builddir} \\\
1453 --offline \\\
1454 --nodeps \\\
1455 %{-f:--force} \\\
1456 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1457 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1458%{nil}
1459
1460# The main macro.
1461# using this macro will append optional-packages.txt to the nocompressdoc list
1462# as it's displayed to user after package install. and adding additional gzip
1463# dep is just waste ;)
1464%pear_package_setup(a:d:n:zDc:) \
1465%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1466%define builddir %{_builddir}/%{srcdir} \
1467%setup -q -c -T %{-D:-D} -n %{srcdir} \
1468%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1469%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1470%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1471%pear_install \
1472%{-z:cd ..} \
1473%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1474cat %{-z:$_N/}.install.log | %__pear_install_log \
1475%undos -f php,html,js,xml \
1476%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1477%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1478%{nil}
1479
1480# Copies extracted PEAR package structure and PEAR registry to buildroot.
1481# Author: Elan Ruusamäe <glen@pld-linux.org>
1482%pear_package_install() \
1483cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1484# tests should not be packaged \
1485%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1486# cleanup backups \
1487find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1488# help the developer out a little: \
1489if [ -f _noautoreq ]; then \
1490 echo "AutoReqdep detected:" \
1491 echo "_noautoreq $(cat _noautoreq)" \
1492fi \
1493%{nil}
1494
1495# Print optional package info for pear packages
1496# Author: Elan Ruusamäe <glen@pld-linux.org>
1497# Usage:
1498# %post -p <lua>
1499# %%pear_package_print_optionalpackages
1500#
1501# Requirements:
1502# BuildRequires: rpmbuild(macros) >= 1.571
1503%pear_package_print_optionalpackages \
1504f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1505if f then \
1506 for l in f:lines() do print(l); end \
1507end \
1508%{nil}
1509
1510
1511# Register OpenLDAP schema.
1512# Author: Elan Ruusamäe <glen@pld-linux.org>
1513#
1514# Usage:
1515# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1516#
1517# -d specify dependant schemas, separated by comma
1518#
1519%openldap_schema_register(d:) \
1520for schema in %*; do \
1521 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1522 %{__sed} -i -e " \
1523 /^include.*local.schema/{ \
1524 iinclude\\t $schema\
1525 } \
1526 " /etc/openldap/slapd.conf \
1527 fi \
1528done \
1529# enable dependant schemas \
1530if [ "%{-d*}" ]; then \
1531 %{__sed} -i -e ' \
1532 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1533 s/^#// \
1534 }' /etc/openldap/slapd.conf \
1535fi \
1536%{nil}
1537
1538# Unregister OpenLDAP schema.
1539# Author: Elan Ruusamäe <glen@pld-linux.org>
1540#
1541# Usage:
1542# %%openldap_schema_unregister %{schemadir}/horde.schema
1543#
1544%openldap_schema_unregister() \
1545for schema in %*; do \
1546 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1547 %{__sed} -i -e " \
1548 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1549 # for symmetry it would be nice if we disable enabled schemas in post, \
1550 # but we really can not do that, it would break something else. \
1551 " /etc/openldap/slapd.conf \
1552 fi \
1553done \
1554%{nil}
1555
1556%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1557
1558
1559# Build modules for kernels 2.6
1560# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1561#
1562# Usage:
1563# %build_kernel_modules -m <modules> -C <directory>
1564#
1565# remember that proper Makefile is still required
1566# Options:
1567# -m <modules> (required) -- comma-separated list of modules to save,
1568# without .ko extension, may be placed in subdirectory
1569# -C <directory> -- change to <directory> before doing anything
1570# -p <arg>, -P <arg> -- arguments passeed to make scripts
1571# -c -- do not execute make clean
1572# <additional arguments> -- all additional arguments will be passed to
1573# make modules
1574#
1575# Additional patching supported via here document. Try:
1576# %build_kernel_modules -m module <<'EOF'
1577# your patch script here
1578# EOF
1579# Don't use it unless patching depends on config options.
1580
1581# Developer note: don't touch it unless you know how to handle '\'.
1582# - \ in script expands to nothing
1583# - \\\ in script expands to \
1584# - \\\ inside definition expands to nothing
1585# - \\\\\\\ inside definition expands to \
1586# - in last line \ has to touch arguments so arguments passing
1587# in new lines (using \) will be supported
1588
1589%build_kernel_modules(p:P:m:C:c) \
1590%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1591 \
1592%define Opts \\\\\\\
1593%if "%{_target_base_arch}" != "%{_arch}" \\\
1594 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1595 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1596 %else \\\
1597 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1598 %endif \\\
1599%else \\\
1600 CC="%{kgcc}" \\\
1601%endif \
1602%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1603 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1604 \
1605%{?-C:cd %{-C*}} \
1606compile() { \
1607 local L="<" PATCH_SH; \
1608 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1609 set -e -x \
1610 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1611 \
1612for cfg in ${cfgs:-dist}; do \
1613 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1614 \
1615 rm -rf o \
1616 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1617 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1618 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1619 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1620 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1621 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1622 else \
1623 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1624 fi \
1625 \
1626 set +x \
1627 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1628 set -x \
1629 \
1630 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1631 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1632 %{-p*} %{-P*} \\\
1633 %{MakeOpts} \
1634 %else \
1635 install -d o/include/config \
1636 touch o/include/config/MARKER \
1637 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1638 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1639 %endif \
1640 \
1641 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1642 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1643 ${1+"$@"} \\\
1644 M=$PWD %{MakeOpts}} \
1645 \
1646 %{__make} -C %{_kernelsrcdir} modules \\\
1647 ${1+"$@"} \\\
1648 M=$PWD %{MakeOpts} \
1649 \
1650 for MODULE in {%{-m*},}; do \
1651 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1652 done \
1653done \
1654%{?-C:cd -} \
1655} \
1656compile %{*}\
1657%{nil}
1658
1659
1660# Install kernel modules built by %build_kernel_modules
1661# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1662#
1663# Usage:
1664# %install_kernel_modules -m <modules> -d <directory>
1665#
1666# Options:
1667# -m <modules> (required) -- comma-separated list of modules to install,
1668# without .ko extension, may be placed in subdirectory
1669# -d <directory> (required) -- in what subdirectory modules should be
1670# installed (eg. misc, kernel/drivers/net)
1671# -s <suffix> -- suffix to use when installing modules, useful when module
1672# with same name exists in kernel already
1673# -n <file> -- name of modprobe config file to use (without .conf extension)
1674# for defining aliases, only useful with -s
1675
1676%install_kernel_modules(m:d:s:n:) \
1677%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1678%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1679%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1680 \
1681%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1682%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1683 \
1684__install_kernel_modules() { \
1685local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1686 \
1687for MODULE in {%{-m*},}; do \
1688 [ -n "${MODULE}" ] || continue \
1689 for cfg in ${cfgs:-dist}; do \
1690 [ "$cfg" = smp ] && suf=smp || suf= \
1691 MNAME=${MODULE##*/} \
1692 install -D ${MODULE}-$cfg.ko \\\
1693 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1694 %{?-s:install -d %{ModprobeD}$suf \
1695 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1696 >> %{ModprobeD}$suf/%{-n*}.conf} \
1697 done \
1698done \
1699} \
1700__install_kernel_modules \
1701%{nil}
1702
1703# patchset macros
1704# Author: Elan Ruusamäe <glen@pld-linux.org>
1705#
1706# Usage:
1707# %patchset_source -f <seq(1) format> <start> [<end>]
1708# %patchset_patch <start> [<end>]
1709#
1710# If <end> is omited, it is assumed to be <start>.
1711#
1712# For example in preamble:
1713# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1714# and in %prep:
1715# %patchset_patch 33 44
1716
1717# generate SourceX urls from range START STOP
1718# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1719# The sources start from 10000
1720%patchset_source(f:b:) %(
1721 base=%{-b*}%{!-b*:10000};
1722 start=$(expr $base + %1);
1723 end=$(expr $base + %{?2}%{!?2:%{1}});
1724 # we need to call seq twice as it doesn't allow two formats
1725 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1726 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1727 paste %{tmpdir}/__ps{1,2};
1728 rm -f %{tmpdir}/__ps{1,2};
1729) \
1730%{nil}
1731
1732# apply sources from %patchset_source
1733# -p specify -pX for %patch line
1734# -b base offset: defaults to 10000
1735%patchset_patch(f:p:b:) %(
1736 base=%{-b*}%{!-b*:10000};
1737 start=$(expr $base + %1);
1738 end=$(expr $base + %{?2}%{!?2:%{1}});
1739 echo ": patchset_patch %1%{?2: to %2}";
1740 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1741) \
1742%{nil}
1743
1744# browser plugins v2
1745# Author: Elan Ruusamäe <glen@pld-linux.org>
1746#
1747# Usage:
1748# %browser_plugins_add_browser <name> -p <plugindir>
1749#
1750# <name> (required) -- name of the browser. usually %{name}.
1751# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1752# -b -- default blacklists
1753# -a <arch> override arch
1754#
1755# Example:
1756# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1757
1758%_browserpluginsconfdir /etc/browser-plugins
1759%_browserpluginsdir %{_libdir}/browser-plugins
1760%update_browser_plugins /usr/sbin/update-browser-plugins || :
1761
1762%browser_plugins_add_browser(p:b:a:) \
1763 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1764 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1765 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1766 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1767 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1768 %{-b:cat >> $blacklist_file %{-b*}} \
1769%{nil}
1770
1771# Helper for LUA.
1772# split string separated by space into quoted list
1773#
1774# Author: Elan Ruusamäe <glen@pld-linux.org>
1775#
1776# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1777%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1778
1779# adjust /etc/shells by adding and removing shells from there
1780# Author: Elan Ruusamäe <glen@pld-linux.org>
1781#
1782# Usage:
1783# %post -p <lua>
1784# %lua_add_etc_shells /bin/sh /bin/pdksh
1785#
1786# %preun -p <lua>
1787# if arg[2] == 0 then
1788# %lua_remove_etc_shells /bin/bash /bin/rbash
1789# end
1790#
1791# Requirements:
1792# BuildRequires: rpmbuild(macros) >= 1.462
1793#
1794
1795%lua_add_etc_shells() \
1796t = {}\
1797f = io.open("/etc/shells", "r")\
1798if f then\
1799 for l in f:lines() do t[l]=l; end\
1800 f:close()\
1801end\
1802for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1803 if not t[s] then\
1804 print("Adding "..s.." to /etc/shells")\
1805 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1806 end\
1807end\
1808%{nil}
1809
1810%lua_remove_etc_shells() \
1811t = {}\
1812f = io.open("/etc/shells", "r")\
1813if f then\
1814 for l in f:lines() do t[l]=l; end\
1815 f:close()\
1816end\
1817for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1818 print("Removing "..l.." from /etc/shells")\
1819 t[l] = nil\
1820end\
1821s=""\
1822for _, l in pairs(t) do\
1823 s=s..l.."\\n"\
1824end\
1825io.open("/etc/shells", "w"):write(s)\
1826%{nil}
1827
1828# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1829#
1830# Author: Elan Ruusamäe <glen@pld-linux.org>
1831#
1832# Usage:
1833# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1834# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1835#
1836# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1837#
1838# Requirements:
1839# BuildRequires: rpmbuild(macros) >= 1.429
1840#
1841%add_etc_shells(p) %{-p:<lua>}\
1842%{expand:%%lua_add_etc_shells %*}\
1843%{nil}
1844
1845%remove_etc_shells(p) %{-p:<lua>}\
1846%{-p:if arg[2] == 0 then}\
1847%{expand:%%lua_remove_etc_shells %*}\
1848%{-p:end} \
1849%{nil}
1850
1851# Check syntax for Python files
1852#
1853# Author: Elan Ruusamäe <glen@pld-linux.org>
1854# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1855#
1856# Usage:
1857# %py_lint src
1858#
1859# Requirements:
1860# BuildRequires: python
1861# BuildRequires: rpmbuild(macros) >= 1.602
1862
1863%py_lint() \
1864__py_lint() { \
1865find "$@" -type f -name '*.py' | python -c ' \
1866import sys \
1867import compiler \
1868\
1869found = err = 0\
1870for f in sys.stdin: \
1871 fd = open(f.rstrip()) \
1872 c = fd.read() \
1873 fd.close() \
1874 found = found + 1 \
1875 try: \
1876 compiler.parse(c) \
1877 except SyntaxError, e: \
1878 print "py_lint: %s: %s" % (f.rstrip(), e) \
1879 err = err + 1\
1880\
1881if not found:\
1882 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
1883 sys.exit(1) \
1884elif err: \
1885 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1886 sys.exit(1) \
1887else: \
1888 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
1889' \
1890}; __py_lint %* \
1891%{nil}
1892
1893# Undos files
1894#
1895# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1896# Author: Elan Ruusamäe <glen@pld-linux.org>
1897#
1898# Usage:
1899# %undos list_of_files
1900# %undos -f EXT[,EXT]
1901# %undos -i -f EXT[,EXT]
1902#
1903# -f EXT[,EXT] - find(1) files by extensions
1904# -i - case insensitive file search
1905#
1906# Example:
1907# Un-DOS all *.js, *.css files
1908# %undos -f js,css
1909# Un-DOS all *.js, *.JS files
1910# %undos -f js -i
1911# undos all Makefiles
1912# %{__find} -name Makefile | xargs %undos
1913#
1914# Requirements:
1915# BuildRequires: sed >= 4.0
1916# BuildRequires: rpmbuild(macros) >= 1.565
1917
1918# NB: make sure this macro stays on one line
1919# NB: make sure it includes newline escape
1920%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1921%{nil}
1922
1923# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1924#
1925# Author: Elan Ruusamäe <glen@pld-linux.org>
1926#
1927# Usage:
1928# -a NAME -- add command named NAME
1929# -d NAME -- remove command named NAME
1930# -f FILE -- specify plugin configuration FILE to extract command definition from
1931#
1932# Sample:
1933# %triggerin -- nagios-nrpe
1934# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1935#
1936# %triggerun -- nagios-nrpe
1937# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1938#
1939# Requirements:
1940# Requires: grep
1941# Requires: sed >= 4.0
1942# BuildRequires: rpmbuild(macros) >= 1.552
1943%nagios_nrpe(a:d:c:f:) {\
1944 m=$(md5sum < /etc/nagios/nrpe.cfg); \
1945 %{-a:# on -a and config exists \
1946 if [ -f /etc/nagios/nrpe.cfg ]; then \
1947 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1948 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1949 fi; \
1950 fi;} \
1951 %{-d:# on package remove, -d and config exists \
1952 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1953 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1954 fi;} \
1955 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1956 %service -q nrpe restart; \
1957 fi; \
1958}%{nil}
1959
1960# Import or update Cacti template.
1961#
1962# Author: Elan Ruusamäe <glen@pld-linux.org>
1963#
1964# Usage:
1965# %cacti_import_template XMLFILE
1966# XMLFILE -- XML template to import
1967#
1968# Sample:
1969# %post
1970# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1971#
1972# Requires: cacti >= 0.8.7e-8
1973# BuildRequires: rpmbuild(macros) >= 1.554
1974
1975%cacti_import_template() {\
1976/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1977}%{nil}
1978
1979# pre/post script for -upstart subpackages
1980#
1981# Author: Jacek Konieczny <jajcus@jajcus.net>
1982#
1983# Usage:
1984# %upstart_post service_name
1985# %upstart_postun service_name
1986#
1987# Sample:
1988# %post upstart
1989# %upstart_post %{name}
1990#
1991# %postun upstart
1992# %upstart_postun %{name}
1993#
1994# Requirements:
1995# BuildRequires: rpmbuild(macros) >= 1.560
1996# Requires: rc-scripts >= 0.4.3
1997
1998# migrate from init script to upstart job
1999%upstart_post() \
2000 if [ -f /var/lock/subsys/%1 ]; then \
2001 /sbin/service --no-upstart %1 stop \
2002 /sbin/service %1 start \
2003 fi
2004
2005# restart the job after upgrade or migrate to init script on removal
2006# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2007# at this point
2008%upstart_postun() \
2009 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2010 /sbin/initctl stop %1 >/dev/null 2>&1 \
2011 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2012 fi
2013
2014# Haskell Macros
2015# BuildRequires: rpmbuild(macros) >= 1.608
2016%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2017
2018# update /usr/lib*/ghc-*/package.conf.d/package.cache
2019# Requires: ghc
2020# BuildRequires: rpmbuild(macros) >= 1.607
2021#
2022%ghc_pkg_recache() {{ \
2023 umask 022; \
2024 /usr/bin/ghc-pkg recache; \
2025};} \
2026%{nil}
2027
2028# EOF
This page took 0.26591 seconds and 4 git commands to generate.